function login() {
  hideLoader();
  const tab = document.querySelector('#filerobot-tab');
  const loginForm = tab.querySelector('#login-form');
  const selectionForm = tab.querySelector('#selection-form')
  const companySelect = tab.querySelector('#company-select');
  const projectSelect = tab.querySelector('#project-select');

  loginForm.addEventListener('submit', async function (event) {
    event.preventDefault();
    showLoader();
    const email = tab.querySelector('#email').value;
    const password = tab.querySelector('#password').value;

    const userData = await send('login', {
      login: { email, password }
    });

    if (userData) {
      saveData('user_uuid', userData.user_uuid);
      saveData('user_email', userData.user_email);
      saveData('session_uuid', userData.session_uuid);
      
      addArrayToDOM(userData.companies, companySelect, 'uuid', 'name');

      loginForm.classList.add('hide');
      selectionForm.classList.remove('hide');
      hideLoader();
    }
  });

  companySelect.addEventListener('change', async function (event) {
    const companyUUID = await loadProjects(event.target.value, projectSelect);
    saveData('company_uuid', companyUUID);
  });

  selectionForm.addEventListener('submit', async function (event) {
    showLoader();
    event.preventDefault();

    await generateSecretKey(projectSelect);
    
    initUploader();
  });
}