async function preferences() {
  const tab = document.querySelector('#preferences-tab');
  const preferencesForm = tab.querySelector('#preferences-form')
  const companySelect = tab.querySelector('#company-select');
  const projectSelect = tab.querySelector('#project-select');
  const openAsLayerCheckbox = tab.querySelector('#open-as-layer');
  const oldCompanyUUID = getData('company_uuid');
  const oldProjectUUID = getData('project_uuid');

  if (parseInt(getData('open_as_layer'))) {
    openAsLayerCheckbox.checked = true;
  }

  openAsLayerCheckbox.addEventListener('change', function (event) {
    saveData('open_as_layer', openAsLayerCheckbox.checked ? 1 : 0);
  })

  await loadCompanies(companySelect);
  await loadProjects(oldCompanyUUID, projectSelect);

  companySelect.addEventListener('change', async function (event) {
    await loadProjects(oldCompanyUUID, projectSelect);
  });

  preferencesForm.addEventListener('submit', async function (event) {
    event.preventDefault();
    
    if (companySelect.value !== oldCompanyUUID) { saveData('company_uuid', companySelect.value); }
    if (projectSelect.value !== oldProjectUUID) {
      saveData('project_uuid', projectSelect.value);
      await generateSecretKey(projectSelect);
    }
    
    location.reload();
  });

  tab.querySelector('#close-button').addEventListener('click', function () { tab.classList.remove('show'); });
}